/*
 * moses3/comboreduct/combo/action.cc
 *
 * Copyright (C) 2002-2008 Novamente LLC
 * All Rights Reserved
 *
 * Written by Nil Geisweiller
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include "action.h"
#include "descriptions.h"

namespace moses3 { namespace combo {

arity_t get_arity(action a)
{
    using namespace action_properties;
    return actions_properties::instance().action_arity(a);
}

std::ostream& operator<<(std::ostream& out, const action& a)
{
    switch (a) {
    case id::sequential_and:
        return out << "and_seq";
    case id::sequential_or:
        return out << "or_seq";
    case id::sequential_exec:
        return out << "exec_seq";
    case id::action_not:
        return out << "action_not";
    case id::action_if:
        return out << "action_boolean_if";
    case id::boolean_action_if:
        return out << "boolean_action_if";
    case id::contin_action_if:
        return out << "contin_action_if";
    case id::action_action_if:
        return out << "action_action_if";
    case id::action_failure:
        return out << "action_failure";
    case id::action_success:
        return out << "action_success";
    case id::action_while:
        return out << "action_while";
    case id::boolean_while:
        return out << "boolean_while";
    case id::return_success:
        return out << "return_success";
    case id::repeat_n:
        return out << "repeat_n";
    default:
        return out << "ACTION : UNKNOWN_HANDLE";
    }
}

}} // ~namespaces combo moses3
