/*
 * moses3/comboreduct/combo/action.h
 *
 * Copyright (C) 2002-2008 Novamente LLC
 * All Rights Reserved
 *
 * Written by Nil Geisweiller
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#ifndef _COMBO_ACTION_H
#define _COMBO_ACTION_H

#include <moses3/util/exceptions.h>
#include "../type_checker/type_tree_def.h"

#include <iostream>
#include <vector>
#include "common_def.h"

namespace moses3 { namespace combo {

namespace id {
    enum action {
        sequential_and, sequential_or, sequential_exec,
        action_not, //negate the action_result of an action, that is
        //action_not(action_succeed)=action_failure
        //action_not(action_failure)=action_succeed
        action_if, //boolean in condition,
                   //action branch (for consistency this is action_boolean_if for i/o - moshe)
        action_boolean_if = action_if, //nasty hack but allowed - do not insert anything between this line and the one above
        boolean_action_if, //action_result in condition, boolean branch
        contin_action_if, //action_result in condition, contin branch
        action_action_if, //action_result in condition, action branch
        action_success, action_failure,
        action_while, boolean_while, return_success, repeat_n,
        action_count
    };
}

typedef id::action action;

//return the arity of an action
//if an argument of the action is arg_list, then the arity is -1
arity_t get_arity(action aa);

std::ostream& operator<<(std::ostream&, const action&);

} // ~namespace combo
} // ~namespace moses3

#endif
