/** ann.h --- 
 *
 * Copyright (C) 2010-2011 OpenCog Foundation
 *
 * Author: Joel Lehman
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef _OPENCOG_ANN_H
#define _OPENCOG_ANN_H

namespace moses3 { namespace combo {

namespace id {
enum ann_id {
    ann, ann_node, ann_input //ann additions
};
}
typedef id::ann_id ann_id;

class ann_type {
public:
    ann_type(unsigned int i, ann_id _id) : idx(i), id(_id) {}
    unsigned int idx;
    ann_id id;

    bool operator<(ann_type rhs) const {
        return idx < rhs.idx;
    } 
    bool operator==(ann_type rhs) const {
        return idx == rhs.idx;
    }
    bool operator!=(ann_type rhs) const {
        return idx != rhs.idx;
    }
};

}} // ~namespaces combo moses3

#endif // _OPENCOG_ANN_H
