/*
 * moses3/comboreduct/combo/definite_object.cc
 *
 * Copyright (C) 2002-2008 Novamente LLC
 * All Rights Reserved
 *
 * Written by Nil Geisweiller
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include "definite_object.h"

#define ACTION_NAME_POSTFIX "_action"

namespace moses3 { namespace combo {

bool is_action_definite_object(const definite_object& d) {
    return std::string::npos != d.rfind(ACTION_NAME_POSTFIX);
}

std::string get_action_name(const definite_object& d) {
    return d.substr(0, d.rfind(ACTION_NAME_POSTFIX));
}

definite_object get_action_definite_object(const std::string& action_name) {
    return definite_object(action_name + std::string(ACTION_NAME_POSTFIX));
}

}} // ~namespaces combo moses3
