/*
 * moses3/comboreduct/crutil/exception.cc
 *
 * Copyright (C) 2002-2008 Novamente LLC
 * All Rights Reserved
 *
 * Written by Moshe Looks
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include "exception.h"

namespace moses3 { namespace combo {

ComboReductException::ComboReductException(std::string m)
  : _message(m) {}
std::string ComboReductException::get_message() const {
    return _message;
}

EvalException::EvalException(vertex v)
    : ComboReductException("Eval Exception"), _vertex(v) {}
vertex EvalException::get_vertex() const {
    return _vertex;
}

TypeCheckException::TypeCheckException(int arg)
    : ComboReductException("Type check Exception"), _arg(arg) {} 

}} // ~namespaces combo moses3
