/*
 * moses3/comboreduct/crutil/exception.h
 *
 * Copyright (C) 2002-2008 Novamente LLC
 * All Rights Reserved
 *
 * Written by Moshe Looks
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#ifndef _COMBOREDUCT_EXCEPTION_H
#define _COMBOREDUCT_EXCEPTION_H

#include <string>
#include <moses3/comboreduct/combo/vertex.h>

namespace moses3 { namespace combo {

class ComboReductException {
protected:
    std::string _message;
public:
    ComboReductException();
    ComboReductException(std::string m = "");

    std::string get_message() const;
};

class EvalException : public ComboReductException {
    vertex _vertex;
public:
    EvalException();
    EvalException(vertex v = vertex());

    vertex get_vertex() const;
};

class TypeCheckException : public ComboReductException {
    int _arg;
public:
    TypeCheckException();
    TypeCheckException(int arg = 0);
};

}} // ~namespaces combo moses3

#endif
