/** gen-table.h --- 
 *
 * Copyright (C) 2011 OpenCog Foundation
 *
 * Author: Nil Geisweiller
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef _OPENCOG_GEN_TABLE_H
#define _OPENCOG_GEN_TABLE_H

#include <boost/program_options.hpp>

namespace moses3 { namespace combo {

using std::pair;
using std::string;
        
// program option names and abbreviations
// for their meanings see options_description in moses-exec.cc
static const pair<string, string> rand_seed_opt("random-seed", "r");
static const pair<string, string> combo_str_opt("combo-program", "y");
static const pair<string, string> nsamples_opt("nsamples", "n");
static const pair<string, string> min_contin_opt("min-contin", "m");
static const pair<string, string> max_contin_opt("max-contin", "M");
static const pair<string, string> header_opt("header", "H");
static const pair<string, string> output_file_opt("output-file", "o");
static const pair<string, string> target_index_opt("target_index", "t");

} // ~namespace combo
} // ~namespace moses3

#endif // _OPENCOG_GEN-TABLE_H
