/*
 * moses3/comboreduct/main/logical-reductor.cc
 *
 * Copyright (C) 2002-2008 Novamente LLC
 * All Rights Reserved
 *
 * Written by Moshe Looks
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include <iostream>

#include <moses3/util/mt19937ar.h>
#include <moses3/util/Logger.h>

#include "../reduct/reduct.h"
#include "../interpreter/eval.h"
#include "../table/table.h"
#include "../table/table_io.h"

using namespace std;
using namespace moses3;
using namespace reduct;

int main()
{
    logger().setPrintErrorLevelStdout();

    moses3::combo::vertex_set ignore_ops;

    const int effort = 3; // effort allocated for reduction (3 is max)

    combo_tree tr;
    while (cin.good()) {
        cin >> tr;
        if (!cin.good())
            break;
        complete_truth_table tt1(tr);
        //cout << "AR" << endl;
        logical_reduce(effort, tr, ignore_ops);
        //cout << "RA" << endl;
        complete_truth_table tt2(tr, integer_log2(tt1.size()));
        cout << tr << endl;
        //cout << "checking tt" << endl;
        if (tt1 != tt2) {
            cout << tt1 << endl << tt2 << endl;
            cerr << "truth-tables don't match!" << endl;
            return 1;
        }
        //cout << "OK" << endl;
    }
    return 0;
}
