/*
 * moses3/comboreduct/reduct/contin_rules.h
 *
 * Copyright (C) 2002-2008 Novamente LLC
 * All Rights Reserved
 *
 * Written by Nil Geisweiller
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#ifndef _REDUCT_CONTIN_RULES_H
#define _REDUCT_CONTIN_RULES_H

#include <moses3/util/RandGen.h>

#include "reduct.h"

#include "../combo/simple_nn.h"
#include "../combo/vertex.h"
#include "../combo/convert_ann_combo.h"

namespace moses3 { namespace reduct {

using namespace moses3::combo;

//ann reduction rule
// WARNING: this rule should only be used alone, not combined with meta_rules
struct ann_rule : public crule<ann_rule> {
    ann_rule() : crule<ann_rule>::crule("ann_rule") {}
    void operator()(combo_tree& tr,combo_tree::iterator it) const
    {
        tree_transform trans;
        ann net = trans.decodify_tree(tr);
        net.reduce();
        tr = trans.encode_ann(net);
    }
};

} // ~namespace reduct
} // ~namespace moses3

#endif
