/*
 * moses3/comboreduct/combo/type_tree_def.cc
 *
 * Copyright (C) 2002-2008 Novamente LLC
 * All Rights Reserved
 *
 * Written by Nil Geisweiller
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include "type_tree_def.h"
#include <moses3/util/oc_assert.h>

namespace moses3 { namespace combo {

bool is_argument_type(type_node n)
{
    return ((int)n) >= id::argument_type;
}

unsigned int arg_to_idx(type_node n)
{
    OC_ASSERT(is_argument_type(n),
              "Cannot find the idx of a non-argument type");
    return (unsigned int)((int)n-(int)id::argument_type+1);
}

}} // ~namespaces combo moses3
