/** algo/deme_optimize.cc ---
 *
 * Copyright (C) 2011 OpenCog Foundation
 *
 * Author: Nil Geisweiller
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <moses3/learning/moses/optimization/optimization.h>

#include "deme_optimize.h"

namespace moses3 {
    
using namespace std;

instance initial_instance(const feature_selection_parameters& fs_params,
                          const field_set& fields,
                          const vector<string>& ilabels)
{
    feature_set init_features = initial_features(ilabels, fs_params);
    instance res(fields.packed_width());
    for (size_t idx : init_features)
        *(fields.begin_bit(res) + idx) = true;
    return res;
}


} // ~namespace moses3
