/** scorers/moses_optim.cc --- 
 *
 * Copyright (C) 2011 OpenCog Foundation
 *
 * Author: Nil Geisweiller <nilg@desktop>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "moses_optim.h"

namespace moses3 {

std::set<arity_t> get_feature_set(const field_set& fields,
                                  const instance& inst)
{
    std::set<arity_t> fs;
    field_set::const_bit_iterator bit = fields.begin_bit(inst);
    for(arity_t i = 0; bit != fields.end_bit(inst); bit++, i++)
        if(*bit)
            fs.insert(i);
    return fs;
}

} // ~namespace moses3
