/*
 * moses3/modes/eda/eda.h
 *
 * Copyright (C) 2002-2008 Novamente LLC
 * All Rights Reserved
 *
 * Written by Moshe Looks
 *            Predrag Janicic
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#ifndef _EDA_EDA_H
#define _EDA_EDA_H

#include "using.h"
#include <moses3/util/tree.h>

namespace moses3 {
namespace moses {

// Storage types for packed populations.
typedef unsigned long int packed_t;
#define bits_per_packed_t (8*sizeof(packed_t))

// Value types accessing unpacked instances.
typedef double       contin_t;  // continuous
typedef unsigned     disc_t;    // discrete
typedef std::string  term_t;
typedef tree<term_t> term_tree;

typedef std::vector<packed_t> instance;

} // ~namespace moses
} // ~namespace moses3

#endif
