/*
 * moses3/learning/moses/eda/initialization.h
 *
 * Copyright (C) 2002-2008 Novamente LLC
 * All Rights Reserved
 *
 * Written by Moshe Looks
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#ifndef _EDA_INITIALIZATION_H
#define _EDA_INITIALIZATION_H

#include "../representation/field_set.h"

//various routines for initializing instances
namespace moses3 { 
namespace moses {

// occam randomize a particular contin or term field. Note that it is
// not strictly occam in the Solomonoff sense because the size is
// uniformely distributed.
void occam_randomize_contin(const field_set&, instance&,
                            field_set::contin_iterator);
void occam_randomize_term(const field_set&, instance&,
                          field_set::const_term_iterator);

//occam randomize all contin or term fields
void occam_randomize_term(const field_set&, instance&);
void occam_randomize_contin(const field_set&, instance&);

//uniformly randomize all bit or disc fields
void uniform_randomize_bit(const field_set&, instance&);
void uniform_randomize_disc(const field_set&, instance&);

//occam randomize all contin and term fields, and uniformly randomize all bit
//and disc fields
void randomize(const field_set&, instance&);

} // ~namespace moses
} // ~namespace moses3

#endif
