/*
 * moses3/learning/moses/main/edaopt.h
 *
 * Copyright (C) 2002-2008 Novamente LLC
 * All Rights Reserved
 *
 * Written by Moshe Looks
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <assert.h>
#include <iostream>
#include <vector>
#include <boost/lexical_cast.hpp>

using namespace std;

// WARNING: the additional arguments must be handled by the caller,
// but it is done here for checking and usage printing.
// This is an ugly but quick fix for the demo programs.
struct optargs
{
    optargs(int argc, char** argv,
            const vector<string>& additional_args = vector<string>()) { 
        if (argc != (5 + static_cast<int>(additional_args.size()))) {
            cerr << "Error: wrong  number of args.\n"
                 << "Usage: " << argv[0] 
                 << " <rand seed> <length> <population size> <num generations> "
                 << usage(additional_args) << endl;
            exit(1);
        }
        try {
            assert(argc >= 5);
            rand_seed = boost::lexical_cast<int>(argv[1]);
            length = boost::lexical_cast<int>(argv[2]);
            popsize = boost::lexical_cast<int>(argv[3]);
            n_select = popsize;
            n_generate = popsize/2;
            max_gens = boost::lexical_cast<int>(argv[4]);
        } catch (...) {
            cerr << "Error: invalid argument\nUsage: " << argv[0]
                 << " <rand seed> <length> <population size> <num generations> "
                 << usage(additional_args) << endl;
            exit(1);
        }
    }
    int rand_seed;
    int length;
    int popsize;
    int n_select;
    int n_generate;
    int max_gens;

private:
    string usage(const vector<string>& args)
    {
        string res;
        for (vector<string>::const_iterator i = args.begin();
            i != args.end(); ++i) {
            res += *i + string(" ");
        }
        return res;
    }
};
