/*
 * moses3/learning/moses/example-progs/headers.h
 *
 * Copyright (C) 2002-2008 Novamente LLC
 * All Rights Reserved
 *
 * Written by Moshe Looks
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/* A collection of assorted headers that the various example programs
 * will need. These define the various optimization algos that get used.
 */

#include <moses3/util/Logger.h>
#include <moses3/util/mt19937ar.h>
#include <moses3/util/selection.h>

#include <moses3/learning/moses/eda/initialization.h>
#include <moses3/learning/moses/eda/local_structure.h>
#include <moses3/learning/moses/eda/logging.h>
#include <moses3/learning/moses/eda/optimize.h>
#include <moses3/learning/moses/eda/replacement.h>
#include <moses3/learning/moses/eda/termination.h>

#include "edaopt.h"
#include "scoring_functions.h"

using namespace moses3;
using namespace moses;

