/*
 * moses3/learning/moses/moses/complexity.h
 *
 * Copyright (C) 2002-2008 Novamente LLC
 * All Rights Reserved
 *
 * Written by Moshe Looks
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#ifndef _COMBO_COMPLEXITY_H
#define _COMBO_COMPLEXITY_H

// Various routines dealing with computin the (algorithmic) complexity
// of particular combo programs.

#include <moses3/comboreduct/combo/vertex.h>
#include <limits>

namespace moses3 { namespace moses {

    // Right now, the algorithmic complexity of any combo program
    // is always an (unsigned) int.  I guess it could be made a float,
    // if need be... there's no fundamental reason for an int here.
    typedef int complexity_t;

    static const complexity_t worst_complexity =
        std::numeric_limits<complexity_t>::min();

    complexity_t tree_complexity(combo::combo_tree::iterator, 
                        bool (*)(const combo::combo_tree::iterator&) = NULL);

    complexity_t tree_complexity(const combo::combo_tree&,
                        bool (*)(const combo::combo_tree::iterator&) = NULL);

} //~namespace moses
} //~namespace moses3

#endif
