/*
 * moses3/util/RandGen.h
 *
 * Copyright (C) 2002-2007 Novamente LLC
 * All Rights Reserved
 *
 * Written by Welter Silva <welter@vettalabs.com>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef _OPENCOG_RAND_GEN_H
#define _OPENCOG_RAND_GEN_H

#include <set>
#include <moses3/util/exceptions.h>

namespace moses3
{

class RandGen
{

public:

    virtual ~RandGen() {}

    // reset the random seed
    virtual void seed(unsigned long) = 0;
    
    // random int between 0 and max rand number.
    virtual int randint() = 0;

    //random float in [0,1]
    virtual float randfloat() = 0;

    //random double in [0,1]
    virtual double randdouble() = 0;

    //random double in [0,1)
    virtual double randDoubleOneExcluded() = 0;

    //random int in [0,n)
    virtual int randint(int n) = 0;

    // return -1 or 1 randonly
    virtual int randPositiveNegative() = 0;

    //random boolean
    virtual bool randbool() = 0;
};

} // ~namespace moses3

#endif // _OPENCOG_RAND_GEN_H
