/*
 * moses3/util/lazy_normal_selector.h
 *
 * Copyright (C) 2002-2007 Novamente LLC
 * All Rights Reserved
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef _OPENCOG_LAZY_NORMAL_SELECTOR_H
#define _OPENCOG_LAZY_NORMAL_SELECTOR_H

#include "lazy_selector.h"
#include "oc_assert.h"

namespace moses3
{

// apply lazy_selector but the select method returns always the same
// number, created for testing
struct lazy_normal_selector : public lazy_selector {
private:
    unsigned int _s;
public:
    lazy_normal_selector(unsigned int n, unsigned int s = 0) :
        lazy_selector(n), _s(s) {
        OC_ASSERT(s < n);
    }
    unsigned int select();
};

} //~namespace moses3

#endif
