/*
 * moses3/comboreduct/combo/definite_object.h
 *
 * Copyright (C) 2002-2008 Novamente LLC
 * All Rights Reserved
 *
 * Written by Nil Geisweiller
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#ifndef _COMBO_DEFINITE_OBJECT_H
#define _COMBO_DEFINITE_OBJECT_H

#include <string>
#include <set>

namespace moses3 { namespace combo {

typedef std::string definite_object;

typedef std::set<definite_object> definite_object_set;
typedef definite_object_set::iterator definite_object_set_it;
typedef definite_object_set::const_iterator definite_object_set_const_it;

//a definite object with suffix _action is a special definite_object
//used to reflect a self or other agent action
//the following methods allows to check wether a definite_object
//is of action type and get the action name (without the suffix "_action")
bool is_action_definite_object(const definite_object& d);
std::string get_action_name(const definite_object& d);
definite_object get_action_definite_object(const std::string& action_name);

}} // ~namespaces combo moses3

#endif
