/*
 * moses3/comboreduct/combo/indefinite_object.h
 *
 * Copyright (C) 2002-2008 Novamente LLC
 * All Rights Reserved
 *
 * Written by Nil Geisweiller
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#ifndef _COMBO_INDEFINITE_OBJECT_H
#define _COMBO_INDEFINITE_OBJECT_H

#include <moses3/util/exceptions.h>

#include "../type_checker/type_tree_def.h"
#include "operator_base.h"

namespace moses3 { namespace combo {
  
//indefinite_object inherits from operator_base
//without additional properties
class indefinite_object_base : public operator_base {
public:
    virtual ~indefinite_object_base() {}
};

typedef const indefinite_object_base* indefinite_object;

typedef std::set<indefinite_object> indefinite_object_set;
typedef indefinite_object_set::iterator indefinite_object_set_it;
typedef indefinite_object_set::const_iterator indefinite_object_set_const_it;

std::ostream& operator<<(std::ostream&, indefinite_object);

} // ~namespace combo
} // ~namespace moses3

#endif

