/*
 * moses3/learning/moses/eda/logging.h
 *
 * Copyright (C) 2002-2008 Novamente LLC
 * All Rights Reserved
 *
 * Written by Moshe Looks
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#ifndef _EDA_LOGGING_H
#define _EDA_LOGGING_H

#include <algorithm>
#include <iostream>
#include <sstream>
#include <moses3/util/Logger.h>

#include "../representation/field_set.h"

namespace moses3 {
namespace moses {

    struct cout_log_best_and_gen
    {
        template<typename It>
        void operator()(It from, It to, const field_set& fs, int gen) const
        {
            if (!logger().isDebugEnabled())
                return;

            if (from == to)
                return;

            It best = std::max_element(from, to);
            logger().debug("Generation: %d", gen);
            std::stringstream ss;
            ss << "Best instance: " << best->second << " "
               << fs.stream(best->first);
            logger().debug(ss.str());
        }
    };

} // ~namespace moses
} // ~namespace moses3

#endif
