/*
 * moses3/learning/moses/moses/using.h
 *
 * Copyright (C) 2002-2008 Novamente LLC
 * All Rights Reserved
 *
 * Written by Moshe Looks
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#ifndef _MOSES_USING_H
#define _MOSES_USING_H

#include <iostream>
#include <set>
#include <functional>
#include <vector>

#include <boost/logic/tribool.hpp>
#include <boost/bind.hpp>
#include <boost/iterator/counting_iterator.hpp>
#include <boost/iterator/transform_iterator.hpp>
#include <boost/iterator/permutation_iterator.hpp>
#include <boost/iterator/indirect_iterator.hpp>

#include <moses3/comboreduct/combo/vertex.h>
#include <moses3/util/Logger.h>

// uncomment this line for debug information to be given during execution
// #define DEBUG_INFO 

namespace moses3 { namespace moses {

    using namespace combo;

    using std::min;
    using std::max;
    using std::accumulate;
    using std::set;
    using std::string;
    using std::unary_function;
    using std::make_pair;
    using std::vector;
    using std::advance;
    using std::cin;
    using std::cout;
    using std::endl;
    using std::istream;
    using std::stringstream;

    using boost::logic::tribool;
    using boost::logic::indeterminate;
    using boost::bind;
    using boost::make_counting_iterator;
    using boost::make_transform_iterator;
    using boost::make_permutation_iterator;
    using boost::make_indirect_iterator;

} // ~namespace moses
} // ~namespace moses3

#endif
