/*
 * moses3/util/oc_assert.cc
 *
 * Copyright (C) 2002-2007 Novamente LLC
 * All Rights Reserved
 *
 * Written by Thiago Maia <thiago@vettatech.com>
 *            Andre Senna <senna@vettalabs.com>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "oc_assert.h"
#include "exceptions.h"

void moses3::cassert(const char * trace, bool condition, const char *fmt, ...)
{
    if (condition) return;

    va_list        ap;
    va_start(ap, fmt);

    char * c_msg = new char[strlen(fmt) + strlen(trace) + 1];
    *c_msg = '\0'; // empty c-string

    strcat(c_msg, fmt);
    strcat(c_msg, trace);

    AssertionException ex = AssertionException(c_msg, ap);
    va_end(ap);

    delete [] c_msg;
    throw ex;
}

void moses3::cassert(const char* trace, bool condition, const std::string& msg) {
    moses3::cassert(trace, condition, msg.c_str());
}

void moses3::cassert(const char * trace, bool condition)
{

    if (condition) return;

    AssertionException ex = AssertionException(trace);
    throw ex;
}

